import Web3 from 'web3';
import { GeneralFunctions, ISpecialTx, Timestamp } from '@energyweb/utils-general';
import { PastEventOptions } from 'web3-eth-contract';
export declare class PublicIssuer extends GeneralFunctions {
    web3: Web3;
    constructor(web3: Web3, address?: string);
    initialize(certificateTopic: number, registryAddress: string, owner: string, txParams: ISpecialTx): Promise<import("web3-core").TransactionReceipt>;
    getAllEvents(eventFilter?: PastEventOptions): Promise<import("web3-eth-contract").EventData[]>;
    encodeIssue(_from: Timestamp, _to: Timestamp, _deviceId: string, txParams?: ISpecialTx): Promise<any>;
    decodeIssue(_data: number[], txParams?: ISpecialTx): Promise<any>;
    getRequestIssue(_requestIssueId: number, txParams?: ISpecialTx): Promise<any>;
    getRequestIssuesForDevice(_deviceId: string, txParams?: ISpecialTx): Promise<any>;
    requestIssue(_data: any, txParams?: ISpecialTx): Promise<import("web3-core").TransactionReceipt>;
    requestIssueFor(_data: any, _forAddress: string, txParams?: ISpecialTx): Promise<import("web3-core").TransactionReceipt>;
    approveIssue(_to: string, _requestId: number, _value: number, _validityData: string, txParams?: ISpecialTx): Promise<import("web3-core").TransactionReceipt>;
    issue(_to: string, _value: number, _data: any, txParams?: ISpecialTx): Promise<import("web3-core").TransactionReceipt>;
    revokeRequest(_requestId: number, txParams?: ISpecialTx): Promise<import("web3-core").TransactionReceipt>;
    revokeCertificate(_certificateId: number, txParams?: ISpecialTx): Promise<import("web3-core").TransactionReceipt>;
    getRegistryAddress(txParams?: ISpecialTx): Promise<any>;
    version(txParams?: ISpecialTx): Promise<any>;
}
